import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import rita.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Type_The_Same_Word_Over_and_Over_Again extends PApplet {



Alarm alarm1;
int timeStarted;
String timeEnded;

RiLexicon lexicon;

PVector skullpos = new PVector(random(100, width-100), random(100, height-100));  // Position of skull graphic
PVector skullvel = new PVector(5, 5);  // Velocity of skull graphic

char[] textbox;         // Array list of chars used in textbox
char[] previousKeys;    // Stores the last few keys pressed
boolean[] redletters;   // Array which includes the index #s of textbox letters which should be red
int textindex = 0;      // Index for the textbox array

float theta = 0.0f;  // Used for visual effects in various spots

String targetWord;  // The word that has to be typed a lot
char[] targetWordArray;

int state = 0;
int power = 100;        // Cyber Defense Points
int maxPower = 100;    // Maximum Cyber Defense Points
int alarmInterval = 115;     // How often power decreases (in milliseconds)
int addAmount = 5;      // The ammount of power gained after each correct word


public void setup()
{
  size(800, 600);
  noSmooth();

  skullpos = new PVector(random(100, width-100), random(100, height-100));  // Position of skull graphic
  skullvel = new PVector(5, 5);  // Velocity of skull graphic

  alarm1 = new Alarm(alarmInterval);

  lexicon = new RiLexicon();

  targetWord = lexicon.randomWord();
  targetWord = targetWord.toUpperCase();
  println(targetWord);

  addAmount = targetWord.length();

  previousKeys = new char[targetWord.length()];

  targetWordArray = new char[targetWord.length()];
  for (int i = 0; i < targetWord.length (); i++) {
    targetWordArray[i] = targetWord.charAt(i);
  }

  textbox = new char[390];
  redletters = new boolean[390];
}


public void draw()
{
  background(30);

  stroke(0, 255, 0);

  // Title screen
  if (state == 0) state0();

  // Main screen
  if (state == 1) state1();

  // Check for game over
  if (power <= 0) {
    state = 3;
    timeEnded = str(millis()-timeStarted);
    power = 100;
  }

  // Game over screen
  if (state == 3) state3();
}

class Alarm
{
  float targetMillis;
  boolean finished;

  Alarm(float targetMillis_)
  {
    targetMillis = targetMillis_ + millis();
  }

  public void run()
  {
    if (millis() >= targetMillis) finished = true;
    else finished = false;
  }
}

public void skull()
{
  line(14,-34,78,-34);

line(78,-34,128,15);

line(128,15,128,56);

line(128,56,119,66);

line(119,66,119,80);

line(119,80,125,80);

line(125,80,125,94);

line(125,94,121,98);

line(121,98,121,109);

line(121,109,116,114);

line(116,114,109,114);

line(109,114,109,123);

line(109,123,106,127);

line(106,127,103,127);

line(103,127,101,125);

line(101,125,101,117);

line(101,117,98,113);

line(98,113,90,113);

line(90,113,83,120);

line(83,120,83,136);

line(83,136,78,141);

line(78,141,61,141);

line(61,141,59,138);

line(59,138,44,138);

line(44,138,40,142);

line(40,142,20,142);

line(20,142,14,135);

line(14,135,14,120);

line(14,120,7,114);

line(7,114,3,114);

line(3,114,0,117);

line(0,117,0,123);

line(0,123,-2,127);

line(-2,127,-5,127);

line(-5,127,-7,124);

line(-7,124,-7,117);

line(-7,117,-9,115);

line(-9,115,-14,115);

line(-14,115,-17,111);

line(-17,111,-17,102);

line(-17,102,-27,93);

line(-27,93,-27,82);

line(-27,82,-22,82);

line(-22,82,-20,80);

line(-20,80,-24,77);

line(-24,77,-24,59);

line(-24,59,-28,54);

line(-28,54,-28,9);

line(-28,9,15,-35);

line(42,55,51,55);

line(51,55,51,66);

line(51,66,56,71);

line(56,71,56,85);

line(56,85,61,89);

line(61,89,61,107);

line(42,55,42,61);

line(42,61,38,66);

line(38,66,38,73);

line(38,73,34,77);

line(34,77,34,102);

line(34,102,40,109);

line(60,52,69,44);

line(69,44,103,44);

line(103,44,112,53);

line(112,53,112,71);

line(112,71,105,78);

line(105,78,105,84);

line(105,84,75,84);

line(75,84,61,69);

line(61,69,61,52);

line(-10,54,-4,47);

line(-4,47,5,47);

line(5,47,9,44);

line(9,44,28,44);

line(28,44,35,51);

line(35,51,35,61);

line(35,61,28,69);

line(28,69,28,75);

line(28,75,22,80);

line(22,80,3,80);

line(3,80,-1,86);

line(-1,86,-7,86);

line(-7,86,-11,82);

line(-11,82,-11,54);

line(40,87,44,87);

line(44,87,44,96);

line(44,96,47,94);

line(47,94,47,87);

line(47,87,54,87);

line(54,87,58,91);

line(58,91,58,98);

line(40,87,37,90);

line(21,138,21,132);

line(21,132,25,132);

line(25,132,31,138);

line(31,138,31,133);

line(31,133,34,133);

line(34,133,37,136);

line(37,136,37,129);

line(37,129,37,124);

line(37,124,40,121);

line(40,121,43,124);

line(43,124,43,136);

line(43,136,49,136);

line(48,136,52,131);

line(52,131,56,135);

line(56,135,60,131);

line(60,131,64,135);

line(64,135,64,138);

line(68,138,72,134);

line(72,134,74,135);

line(74,135,78,135);

line(78,133,78,138);
}
// Letters needed: 

// Each letter will be a base of 10 points across. For now they'll
// all be capital.

// x, y = position (top-left corner); s = scale;
public void letter(char character, float x, float y, float s)
{  
  if (character == 'A')
  {
    line(5.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(5.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(3.5f*s+x, 5.0f*s+y, 6.5f*s+x, 5.0f*s+y);
  }

  if (character == 'B')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 6.0f*s+x, 2.0f*s+y);
    line(6.0f*s+x, 2.0f*s+y, 8.0f*s+x, 3.0f*s+y);
    line(8.0f*s+x, 3.0f*s+y, 8.0f*s+x, 4.0f*s+y);
    line(8.0f*s+x, 4.0f*s+y, 6.0f*s+x, 5.0f*s+y);
    line(6.0f*s+x, 5.0f*s+y, 8.0f*s+x, 6.0f*s+y);
    line(8.0f*s+x, 6.0f*s+y, 8.0f*s+x, 7.0f*s+y);
    line(8.0f*s+x, 7.0f*s+y, 6.0f*s+x, 8.0f*s+y);
    line(6.0f*s+x, 8.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 6.0f*s+x, 5.0f*s+y);
  }

  if (character == 'C')
  {
    line(8.0f*s+x, 2.0f*s+y, 2.0f*s+x, 2.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'D')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 5.0f*s+x, 2.0f*s+y);
    line(5.0f*s+x, 2.0f*s+y, 8.0f*s+x, 3.0f*s+y);
    line(8.0f*s+x, 3.0f*s+y, 8.0f*s+x, 7.0f*s+y);
    line(8.0f*s+x, 7.0f*s+y, 5.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 5.0f*s+x, 8.0f*s+y);
  }

  if (character == 'E')
  {
    line(8.0f*s+x, 2.0f*s+y, 2.0f*s+x, 2.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'F')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
  }

  if (character == 'G')
  {
    line(8.0f*s+x, 2.0f*s+y, 2.0f*s+x, 2.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(8.0f*s+x, 8.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(8.0f*s+x, 5.0f*s+y, 6.0f*s+x, 5.0f*s+y);
  }

  if (character == 'H')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'I')
  {
    line(8.0f*s+x, 2.0f*s+y, 2.0f*s+x, 2.0f*s+y);
    line(5.0f*s+x, 2.0f*s+y, 5.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'J')
  {
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 2.0f*s+x, 6.0f*s+y);
  }

  if (character == 'K')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 4.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(2.0f*s+x, 4.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'L')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'M')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 5.0f*s+x, 6.0f*s+y);
    line(5.0f*s+x, 6.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'N')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'O')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'P')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(8.0f*s+x, 5.0f*s+y, 2.0f*s+x, 5.0f*s+y);
  }

  if (character == 'Q')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 7.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 7.0f*s+x, 2.0f*s+y);
    line(7.0f*s+x, 2.0f*s+y, 7.0f*s+x, 7.0f*s+y);
    line(2.0f*s+x, 7.0f*s+y, 7.0f*s+x, 7.0f*s+y);
    line(6.0f*s+x, 6.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }
  if (character == 'R')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'S')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 5.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(8.0f*s+x, 5.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == 'T')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(5.0f*s+x, 2.0f*s+y, 5.0f*s+x, 8.0f*s+y);
  }

  if (character == 'U')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(8.0f*s+x, 8.0f*s+y, 8.0f*s+x, 2.0f*s+y);
  }

  if (character == 'V')
  {
    line(2.0f*s+x, 2.0f*s+y, 5.0f*s+x, 8.0f*s+y);
    line(5.0f*s+x, 8.0f*s+y, 8.0f*s+x, 2.0f*s+y);
  }

  if (character == 'W')
  {
    line(2.0f*s+x, 2.0f*s+y, 4.0f*s+x, 8.0f*s+y);
    line(4.0f*s+x, 8.0f*s+y, 5.0f*s+x, 5.0f*s+y);
    line(5.0f*s+x, 5.0f*s+y, 6.0f*s+x, 8.0f*s+y);
    line(6.0f*s+x, 8.0f*s+y, 8.0f*s+x, 2.0f*s+y);
  }

  if (character == 'X')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 2.0f*s+y);
  }

  if (character == 'Y')
  {
    line(2.0f*s+x, 2.0f*s+y, 5.0f*s+x, 5.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 5.0f*s+x, 5.0f*s+y);
    line(5.0f*s+x, 5.0f*s+y, 5.0f*s+x, 8.0f*s+y);
  }

  if (character == 'Z')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  } 

  if (character == '0')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == '1')
  {
    line(4.0f*s+x, 2.0f*s+y, 5.0f*s+x, 2.0f*s+y);
    line(5.0f*s+x, 2.0f*s+y, 5.0f*s+x, 8.0f*s+y);
    line(3.0f*s+x, 8.0f*s+y, 7.0f*s+x, 8.0f*s+y);
  }

  if (character == '2')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == '3') 
  {
    line(8.0f*s+x, 2.0f*s+y, 2.0f*s+x, 2.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == '4') 
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 5.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
  }

  if (character == '5')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 5.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(8.0f*s+x, 5.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == '6')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(8.0f*s+x, 5.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == '7')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == '8')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == '9')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 5.0f*s+y);
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(8.0f*s+x, 2.0f*s+y, 8.0f*s+x, 8.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 8.0f*s+y);
  }

  if (character == ':')
  {
    point(2.0f*s+x, 3.0f*s+y);
    point(2.0f*s+x, 7.0f*s+y);
  }

  if (character == '-')
  {
    line(2.0f*s+x, 5.0f*s+y, 8.0f*s+x, 5.0f*s+y);
  }

  if (character == '>')
  {
    line(2.0f*s+x, 2.0f*s+y, 8.0f*s+x, 5.0f*s+y);
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 5.0f*s+y);
  }

  if (character == '!')
  {
    line(2.0f*s+x, 2.0f*s+y, 2.0f*s+x, 6.0f*s+y);
    point(2.0f*s+x, 8.0f*s+y);
  }

  if (character == '%')
  {
    line(2.0f*s+x, 8.0f*s+y, 8.0f*s+x, 2.0f*s+y);
    point(3.0f*s+x, 3.0f*s+y);
    point(7.0f*s+x, 7.0f*s+y);
  }

  if (character == '"')
  {
    line(3.0f*s+x, 2.0f*s+y, 3.0f*s+x, 5.0f*s+y);
    line(7.0f*s+x, 2.0f*s+y, 7.0f*s+x, 5.0f*s+y);
  }
}

// Displays a String using the letters() function
// DOES NOT WORK WITH PROCESSING.JS (FUCK)

public void words(String words, float x, float y, float s)
{
  for (int i = 0; i < words.length(); i++)
  {
    letter(words.charAt(i), (s*10)*i+x, y, s);
  }
}
public void mouseClicked()
{
  if (state == 0) state = 1;
  timeStarted = millis();
}


public void keyPressed()
{
  if (key >= 'a'& key <= 'z')
  {
    char lastKey = Character.toUpperCase(key);
    textbox[textindex] = lastKey;
    redletters[textindex] = false;

    for ( int i = previousKeys.length-1; i >= 0; i-- ) {
      if (i > 0) 
        previousKeys[i] = previousKeys[i-1];
      else
        previousKeys[i] = lastKey;
    }

    // If last key pressed was the last letter of the target word
    if (lastKey == targetWord.charAt(targetWord.length()-1))
    {
      // Check the last few keys typed were the same as the target word
      for (int i = 0; i < previousKeys.length-1; i++) {
        if (previousKeys[i] != targetWord.charAt(targetWord.length()-1-i)) {
          i = previousKeys.length;
        } else {
          if (i == previousKeys.length-2) {
            for (int j = 0; j < previousKeys.length; j++) {
              redletters[textindex-j] = true;
            }
            power += addAmount;
          }
        }
      }
    }

    textindex++;
    if (textindex == 390) {
      previousKeys = new char[targetWord.length()];
    }
    println(textindex);
    textindex %= 390;
  }
}

public void state0()
{
  // Display 'TYPE'
  // Oscillate alpha value
  theta += 0.05f;
  float a = (sin(theta)+1) * 100;
  
  
  stroke(0, 100+a, 0);
  char[] title1 = {'T', 'Y', 'P', 'E'};
  for (int i = 0; i < title1.length; i++)
  {
    letter(title1[i], 150*i+110, 10, 10);
  }
  
  char[] title2 = {'T', 'H', 'E', ' ', 'S', 'A', 'M', 'E'};
  for (int i = 0; i < title2.length; i++)
  {
    letter(title2[i], 50*i+200, 125, 3);
  }    
  
  char[] title3 = {'W','O','R','D'};
  for (int i = 0; i < title3.length; i++)
  {
    letter(title3[i], 189*i+25, 155, 18);
  } 

  char[] title4 = {'O','V','E','R',' ','A','N','D',' ','O','V','E','R'};
  for (int i = 0; i < title4.length; i++)
  {
    letter(title4[i], 55*i+45, 350, 6);
  } 
  
  if (a > 50) stroke(0, 200, 0);
  else stroke(0);
  // Display '- CLICK TO BEGIN -'
  char[] title5 = {'-', ' ', 'C', 'L', 'I', 'C', 'K', ' ', 'T', 'O', ' ', 'B', 'E', 'G', 'I', 'N', '-'};
  for (int i = 0; i < title5.length; i++)
  {
    letter(title5[i], 30*i+125, 450, 3);
  }   
}
public void state1()
{
  alarm1.run();
  if (alarm1.finished) {
    power -= 1;
    alarm1 = new Alarm(alarmInterval);
  }
  
  // Set lines to green
  stroke(0, 255, 0);
  String time = str(millis()-timeStarted);

  // Display 'TERMINAL ACTIVE'
  stroke(0, 255, 0);
  char[] terminalActive = {
    'T', 'E', 'R', 'M', 'I', 'N', 'A', 'L', ' ', 'A', 'C', 'T', 'I', 'V', 'E',' ','F','O','R'
  };
  String terminal = "TERMINAL ACTIVE FOR "+time+" MILLISECONDS";
  for (int i = 0; i < terminalActive.length; i++)
  {
    words(terminal, 10, 10, 2);
  }

  // Display '----------'
  char[] hyphens = {
    '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-', '-'
  };
  for (int i = 0; i < hyphens.length; i++)
  {
    letter(hyphens[i], 20*i+10, 40, 2);
  }

  // Display 'AVAILABLE COMMANDS'
  char[] enterCommand = {
    'T', 'A', 'R', 'G', 'E', 'T', ' ', 'W', 'O', 'R', 'D', ':'
  };
  for (int i = 0; i < enterCommand.length; i++) {
    letter(enterCommand[i], 20*i+10, 70, 2);
  }

  // Display target word
  for (int i = 0; i < targetWordArray.length; i++) {
    letter(targetWordArray[i], 50*i+10, 100, 5);
  }
  
  char[] typeType = {
    'T','Y','P','E','!',' ','T','Y','P','E','!',' ','T','Y','P','E','!'
  };
  for (int i = 0; i < typeType.length; i++) {
    letter(typeType[i], 20*i+10, 164, 2);
  }


  // Display text box (test for size)
  noFill();
  for (int i = 0; i < textbox.length; i++)
  {
    // See if this letter should be colored red
    if (redletters[i] == true) stroke(200, 255, 175);
    else stroke(0, 255, 0);
    // Display letters
    letter(textbox[i], 20*(i%39)+10, 200+(PApplet.parseInt(i/39))*30, 2);
  }

  // Display cyber defenses bar text
  stroke(0, 255, 0);
  char[] cdBar = {
    'P','O','W','E','R',' ','L','E','V','E','L',':'
  };
  for (int i = 0; i < cdBar.length; i++)
  {
    letter(cdBar[i], 10*i+10, 500, 1);
  }

  // Display cyber-defenses bar
  rectMode(CORNER);
  power = constrain(power,0,100);
  float rectEnd = map(power, 0, maxPower, 0, 780);
  rect(10, 520, rectEnd, 65);
}


public void state3()
{   
  // Display letter trails
  for (int j = 0; j < 40; j++)
  {
    theta += .001f;
    float g = sin(theta) * 30;
    stroke(100, map(j*3, 0, 255, g, 75), 0, 255-3);
   
    int xoffset = j*8;
    
    // Display 'YOU'
    char[] you = {'Y', 'O', 'U'};
    for (int i = 0; i < you.length; i++)
    {
      letter(you[i], 50*i+160, 40+xoffset*2, 5);
    } 
    
    // Display 'HAVE'
    char[] have = {'H', 'A', 'V', 'E'};
    for (int i = 0; i < have.length; i++)
    {
      letter(have[i], 50*i+360, 40+xoffset*2, 5);
    }
    
    // Display 'HACKED'
    char[] hacked = {'F','A','I','L','E','D'};
    for (int i = 0; i < hacked.length; i++)
    {
      letter(hacked[i], 150*(i*0.75f)+35, 101+xoffset*2, 15);
    }    
  }
  
  // Display letters themselves
  stroke(255, 0, 0);
  // Display 'YOU'
  char[] you = {'Y', 'O', 'U'};
  for (int i = 0; i < you.length; i++)
  {
    letter(you[i], 50*i+160, 40, 5);
  } 
  
  // Display 'HAVE'
  char[] have = {'H', 'A', 'V', 'E'};
  for (int i = 0; i < have.length; i++)
  {
    letter(have[i], 50*i+360, 40, 5);
  }
  
  // Display 'HACKED'
  char[] hacked = {'F','A','I','L','E','D'};
  for (int i = 0; i < hacked.length; i++)
  {
    letter(hacked[i], 150*(i*0.75f)+35, 100, 15);
  }
  
  stroke(0, 255, 0);
  String yourword = "TARGET WORD: "+targetWord;
  String survivaltime = "YOU SURVIVED FOR: "+timeEnded+" MILLISECONDS";
  
  words(yourword, 50, 500, 3);
  words(survivaltime, 50, 530, 2);
  
  pushMatrix();
  translate(skullpos.x, skullpos.y);
  skullpos.x = constrain(skullpos.x, 0, width-50);
  skullpos.y = constrain(skullpos.y, 0, height-100);
  scale(1.5f);
  stroke(0,255,0,50);
  skull();
  popMatrix();
  
  if (skullpos.x <= 0 || skullpos.x >= width-50) skullvel.x *= -1;
  if (skullpos.y <= 0 || skullpos.y >= height-100) skullvel.y *= -1;
  skullpos.add(skullvel);
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Type_The_Same_Word_Over_and_Over_Again" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
