import rita.*;

Alarm alarm1;
int timeStarted;
String timeEnded;

RiLexicon lexicon;

PVector skullpos = new PVector(random(100, width-100), random(100, height-100));  // Position of skull graphic
PVector skullvel = new PVector(5, 5);  // Velocity of skull graphic

char[] textbox;         // Array list of chars used in textbox
char[] previousKeys;    // Stores the last few keys pressed
boolean[] redletters;   // Array which includes the index #s of textbox letters which should be red
int textindex = 0;      // Index for the textbox array

float theta = 0.0;  // Used for visual effects in various spots

String targetWord;  // The word that has to be typed a lot
char[] targetWordArray;

int state = 0;
int power = 100;        // Cyber Defense Points
int maxPower = 100;    // Maximum Cyber Defense Points
int alarmInterval = 115;     // How often power decreases (in milliseconds)
int addAmount = 5;      // The ammount of power gained after each correct word


void setup()
{
  size(800, 600);
  noSmooth();

  skullpos = new PVector(random(100, width-100), random(100, height-100));  // Position of skull graphic
  skullvel = new PVector(5, 5);  // Velocity of skull graphic

  alarm1 = new Alarm(alarmInterval);

  lexicon = new RiLexicon();

  targetWord = lexicon.randomWord();
  targetWord = targetWord.toUpperCase();
  println(targetWord);

  addAmount = targetWord.length();

  previousKeys = new char[targetWord.length()];

  targetWordArray = new char[targetWord.length()];
  for (int i = 0; i < targetWord.length (); i++) {
    targetWordArray[i] = targetWord.charAt(i);
  }

  textbox = new char[390];
  redletters = new boolean[390];
}


void draw()
{
  background(30);

  stroke(0, 255, 0);

  // Title screen
  if (state == 0) state0();

  // Main screen
  if (state == 1) state1();

  // Check for game over
  if (power <= 0) {
    state = 3;
    timeEnded = str(millis()-timeStarted);
    power = 100;
  }

  // Game over screen
  if (state == 3) state3();
}

